'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styles = require('@material-ui/core/styles');

var _Button = require('@material-ui/core/Button');

var _Button2 = _interopRequireDefault(_Button);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _defaultColors = require('../js/defaultColors');

var _defaultColors2 = _interopRequireDefault(_defaultColors);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const styles = {
  button: {
    fontFamily: '"Poppins", sans-serif',
    fontSize: 16,
    fontWeight: 'bold',
    height: 60,
    borderRadius: 30,
    margin: 0,
    paddingLeft: 20,
    paddingRight: 20,
    boxSizing: 'border-box',
    lineHeight: '24px'
  },
  noWrap: {
    whiteSpace: 'nowrap'
  },
  light: {
    color: _defaultColors2.default.darkBackgroundColor + ' !important',
    background: _defaultColors2.default.lightBackgroundColor,
    border: '1px solid ' + _defaultColors2.default.darkBackgroundColor
  },
  dark: {
    color: _defaultColors2.default.buttonTextColor + ' !important',
    background: _defaultColors2.default.darkBackgroundColor + ' !important'
  },
  disabledLight: {
    color: _defaultColors2.default.disabledBackgroundColor + ' !important',
    background: 'none',
    border: '1px solid ' + _defaultColors2.default.disabledBackgroundColor
  },
  disabledDark: {
    color: _defaultColors2.default.disabledTextColor + ' !important',
    background: _defaultColors2.default.disabledBackgroundColor + ' !important'
  },
  buttonError: {
    border: '1.5px solid ' + _defaultColors2.default.errorColor + ' !important'
  }
};

class BtuButton extends _react.Component {
  render() {
    const {
      children,
      classes,
      style,
      id,
      height,
      action,
      disabled,
      textWrap,
      light,
      error,
      width,
      maxWidth,
      title
    } = this.props;

    return _react2.default.createElement(
      _Button2.default,
      {
        id: id,
        disabled: disabled,
        onClick: action,
        className: (0, _classnames2.default)({
          [classes.button]: true,
          [classes.noWrap]: !textWrap,
          [classes.light]: light && !disabled,
          [classes.dark]: !light && !disabled,
          [classes.disabledLight]: light && disabled,
          [classes.disabledDark]: !light && disabled,
          [classes.buttonError]: error
        }),
        style: Object.assign(style !== undefined ? style : {}, { width, height, maxWidth })
      },
      title || children
    );
  }
}

// ...{
//   width,
//   height,
//   maxWidth,
// },

exports.default = (0, _styles.withStyles)(styles)(BtuButton);