'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ethers = require('ethers');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _reactMultiLang = require('react-multi-lang');

var _styles = require('@material-ui/core/styles');

var _IconButton = require('@material-ui/core/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _Dialog = require('@material-ui/core/Dialog');

var _Dialog2 = _interopRequireDefault(_Dialog);

var _DialogActions = require('@material-ui/core/DialogActions');

var _DialogActions2 = _interopRequireDefault(_DialogActions);

var _DialogContent = require('@material-ui/core/DialogContent');

var _DialogContent2 = _interopRequireDefault(_DialogContent);

var _DialogContentText = require('@material-ui/core/DialogContentText');

var _DialogContentText2 = _interopRequireDefault(_DialogContentText);

var _Grid = require('@material-ui/core/Grid');

var _Grid2 = _interopRequireDefault(_Grid);

var _Details = require('@material-ui/icons/Details');

var _Details2 = _interopRequireDefault(_Details);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

var _TextField = require('./TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _images = require('../assets/images');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class WalletDialog extends _react2.default.Component {
  constructor(props) {
    super(props);

    this.state = {
      open: this.props.isOpen ? true : false,
      status: 'notConNoWal',
      checkValitidy: false,
      ethAddressInput: {
        value: '',
        isValid: false
      }
    };
    this.popUp = this.popUp.bind(this);
  }

  componentDidMount() {
    if (sessionStorage.getItem('BTU-walletAddr')) {
      this.setState({ status: 'isCon' });
    }
  }

  handleClickOpen() {
    const tmpStatus = sessionStorage.getItem('BTU-walletAddr') ? 'isCon' : 'notConNoWal';

    this.setState({
      open: true,
      status: tmpStatus
    });
  }

  handleClose() {
    const tmpStatus = sessionStorage.getItem('BTU-walletAddr') ? 'isCon' : 'notConNoWal';

    this.setState({
      open: false,
      status: tmpStatus
    });
  }

  onClickCreateWal() {
    if (/Mobi|Android/i.test(navigator.userAgent)) {
      window.open('https://trustwallet.com/', '_blank');
    } else if ((0, _reactMultiLang.getLanguage)() === 'fr') {
      window.open('https://cryptoast.fr/tutoriel-metamask/', '_blank');
    } else {
      window.open('https://metamask.io', '_blank');
    }
    this.setState({ status: 'walCreated' });
  }

  onClickHasWal() {
    this.setState({ status: 'inputWal' });
  }

  onClickInputWal() {
    this.setState({ status: 'isCon' });
  }

  onClickConnect() {
    const { onInputWallet } = this.props;
    const addrInput = document.querySelector('#addrWallet');

    // If wallet installed, reload page to detect it
    if (!addrInput) {
      window.location.reload();
      return;
    }

    // If wallet address is invalid, show error
    if (addrInput && addrInput.value === '' || !addrInput.value || addrInput.value.length < 42 || !_ethers.ethers.utils.isHexString(addrInput.value)) {
      this.setState({ checkValidity: true });
      return;
    }

    onInputWallet(addrInput.value);
    this.setState({
      open: false,
      status: 'isCon',
      checkValidity: false
    });
  }

  onClickConnectInput() {
    const {
      ethAddressInput
    } = this.state;

    if (ethAddressInput.isValid) {
      this.onClickConnect();
    } else {
      this.setState({
        checkValidity: true
      });
    }
  }

  validateEthAddress(value) {
    const pattern = new RegExp('^0[xX][0-9A-Fa-f]{40}$');
    return pattern.test(value);
  }

  popUp(props) {
    const { classes } = this.props;
    // const { status } = this.state

    return _react2.default.createElement(
      'div',
      { className: classes.root },
      _react2.default.createElement(
        _DialogContent2.default,
        { className: classes.contentRoot },
        _react2.default.createElement('img', { src: props.img, alt: '' }),
        _react2.default.createElement(
          _DialogContentText2.default,
          { id: 'alert-dialog-description' },
          props.text.map(item => _react2.default.createElement(
            'span',
            {
              key: item,
              className: (0, _classnames2.default)({
                [classes.dialogText]: true,
                [classes.addressText]: item === sessionStorage.getItem('BTU-walletAddr')
              })
            },
            item
          ))
        )
      ),
      _react2.default.createElement(
        _DialogActions2.default,
        { className: classes.actions },
        _react2.default.createElement(
          _Grid2.default,
          { container: true, spacing: 8 },
          _react2.default.createElement(
            _Grid2.default,
            { item: true, xs: props.fullWidthButtons ? 12 : 6 },
            props.leftButtonText && _react2.default.createElement(_Button2.default, {
              title: props.leftButtonText,
              action: props.leftButtonClick,
              width: '100%',
              light: !props.fullWidthButtons,
              textWrap: true
            })
          ),
          _react2.default.createElement(
            _Grid2.default,
            { item: true, xs: props.fullWidthButtons ? 12 : 6 },
            props.rightButtonText && _react2.default.createElement(_Button2.default, {
              title: props.rightButtonText,
              action: props.rightButtonClick,
              width: '100%',
              light: props.fullWidthButtons,
              textWrap: true
            })
          )
        )
      )
    );
  }

  onEthAddressInputChange(newValue) {
    this.setState({
      ethAddressInput: newValue
    });
  }

  render() {
    const {
      classes,
      t
    } = this.props;

    const {
      status,
      open,
      checkValidity,
      ethAddressInput
    } = this.state;

    const notConNoWal = this.popUp({
      img: _images.electronicWallet,
      text: [t('dappBar.usingBTU.using'), t('dappBar.usingBTU.choiceConnected')],
      leftButtonText: t('dappBar.usingBTU.createWallet'),
      leftButtonClick: this.onClickCreateWal.bind(this),
      rightButtonText: t('dappBar.usingBTU.hasWallet'),
      rightButtonClick: this.onClickHasWal.bind(this),
      fullWidthButtons: true
    });

    const notConHasWal = this.popUp({
      img: _images.electronicWallet,
      text: [t('dappBar.usingBTU.usingConnected')],
      leftButtonText: t('dappBar.usingBTU.changeWallet'),
      leftButtonClick: this.onClickHasWal.bind(this),
      rightButtonText: t('dappBar.usingBTU.connection'),
      rightButtonClick: this.onClickConnect.bind(this)
    });

    const inputWal = _react2.default.createElement(
      'div',
      { className: classes.root },
      _react2.default.createElement(
        _DialogContent2.default,
        { className: classes.contentRoot },
        _react2.default.createElement('img', { src: _images.withoutWallet, alt: '' }),
        _react2.default.createElement(
          _DialogContentText2.default,
          { id: 'alert-dialog-description' },
          'Please enter your ETH address'
        )
      ),
      _react2.default.createElement(_TextField2.default, {
        title: t('dappBar.inputWallet.addrBTU'),
        inputId: 'addrWallet',
        value: ethAddressInput.value,
        placeholder: t('dappBar.inputWallet.placeholder'),
        validate: this.validateEthAddress,
        onChange: this.onEthAddressInputChange.bind(this),
        required: true,
        checkValidity: checkValidity,
        requiredMessage: t('dappBar.inputWallet.requiredETH'),
        invalidMessage: t('dappBar.inputWallet.invalidETH')
      }),
      _react2.default.createElement(
        _DialogActions2.default,
        { className: classes.actions },
        _react2.default.createElement(_Button2.default, {
          title: t('dappBar.inputWallet.inputCo'),
          action: this.onClickConnectInput.bind(this)
        })
      )
    );

    const walCreated = this.popUp({
      img: _images.withoutWallet,
      text: [t('dappBar.isCreated.afterCreate')],
      leftButtonText: t('dappBar.isCreated.hasCreated'),
      leftButtonClick: this.onClickConnect.bind(this),
      rightButtonText: t('dappBar.isCreated.hasWallet'),
      rightButtonClick: this.onClickHasWal.bind(this),
      fullWidthButtons: true
    });

    // const transformWallet = store && store.get('addresseBTU')
    // ? store.get('addresseBTU').substring(0, 5) + '...' + store.get('addresseBTU').substring(38, 42)
    // : ''

    const isCon = this.popUp({
      img: _images.withoutWallet, //Change space to , v
      text: [t('dappBar.isConnected.nowCo') + ": " + sessionStorage.getItem('BTU-walletAddr')],
      leftButtonText: t('dappBar.usingBTU.changeWallet'),
      leftButtonClick: this.onClickHasWal.bind(this),
      fullWidthButtons: true
    });

    return _react2.default.createElement(
      _react2.default.Fragment,
      null,
      _react2.default.createElement(
        _IconButton2.default,
        { className: classes.imgLogo, variant: 'outlined', color: 'primary', onClick: this.handleClickOpen.bind(this) },
        _react2.default.createElement(_Details2.default, { className: classes.arrowButton })
      ),
      _react2.default.createElement(
        _Dialog2.default,
        {
          open: open,
          onClose: this.handleClose.bind(this),
          'aria-labelledby': 'alert-dialog-title',
          'aria-describedby': 'alert-dialog-description'
        },
        {
          notConNoWal,
          notConHasWal,
          inputWal,
          walCreated,
          isCon
        }[status]
      )
    );
  }
}

const styles = {
  root: {
    maxWidth: 400,
    textAlign: 'center',
    padding: 20
  },
  contentRoot: {
    textAlign: 'center'
  },
  imgLogo: {
    color: 'white',
    padding: 'unset'
  },
  arrowButton: {
    width: 20,
    height: 16
  },
  select: {
    background: '#5bace2 !important',
    height: 45,
    borderRadius: 25,
    paddingLeft: 20,
    paddingRight: 20,
    marginTop: '5px !important',
    overflow: 'hidden',
    fontSize: 15,
    textTransform: 'none',
    justifyContent: 'left',
    position: 'relative',
    color: 'white',
    marginBottom: 20
  },
  actions: {
    justifyContent: 'center',
    flexDirection: 'column'
  },
  wide: {
    width: '85%',
    textAlign: 'center',
    display: 'unset'
  },
  input: {
    width: '85%',
    margin: '0 auto 0 auto'
  },
  normalButton: {
    transform: 'translate(0px, -5px)'
  },
  dialogText: {
    marginTop: 10,
    display: 'block'
    // 'word-wrap': 'break-word',
  },
  addressText: {
    fontSize: 12
  }
};

exports.default = (0, _styles.withStyles)(styles)((0, _reactMultiLang.translate)(WalletDialog));